NaNoGenLab
==========

Herein may be found novel-generation experiments for [NaNoGenMo 2014][]
conducted under the auspices of [Cat's Eye Technologies][].

Note that the word "experiment", like the word "novel", may mean many things.

> Isaac Asimov has suggested a triage process which divides scientific
> claims into three groups: mundane, unusual and hogwash [my terms].
> As an example, a claim that "My computer has generated 50,000 words of text"
> is pretty mundane.  No-one would disbelieve me, but they wouldn't be very
> interested.  A claim that "My computer has generated a 50,000-word story"
> would probably result in mild disbelief and requests to have a look.  Finally,
> a claim that "My computer has generated a 50,000-word [novel][]" would be
> greeted with cries of "Hogwash!"

— _with apologies to the sci.skeptic FAQ_

Everything in this repository is in the public domain; see the file
UNLICENSE in the root directory for more information.

An experiment a day during November
-----------------------------------

Having not come up with a really ripping idea for a novel to generate,
I [decided][] fairly early on in November to make my goal for this NaNoGenMo
to run one little experiment per day (on average) in the generation,
transformation, and general mutilation of text (and images, yes those too.
See the link for more details.)

In roughly chronicological order (based on when they were started, not when
they were finished), the experiments have been:

1. join-at-pivot
2. levenshtein-equidistant
3. infix-neologisms
4. pyramidal-reduction
5. checkerboard-layout
6. narrative-makefile
7. eliza-vs-eliza
8. naive-cut-up
9. poetic-inventory
10. wikimedia-illustrations
11. evaporating-text
12. shanty-generator
13. reluctance-generator
14. columnar-cthulhuian
15. ending-concordance
16. find-cut-up-regions
17. levenshtein-pathway
18. selfref-timeline
19. perm-count-finder
20. uniquified-novel
21. binary-phone-words
22. recursive-template
23. infinite-grammar
24. quick-and-dirty-markov
25. wordplay-finder
26. levenshtein-word-replacement
27. sensible-paste-up
28. joke-o-matic
29. levenshtein-swapper
30. advanced-spoonerizer

Plus special bonus experiments!

31. narrated-card-game
32. multisource-markov

Plus experiments that were started but are not considered proper experiments
mainly because they don't really add anything on top of one of the other
experiments:

* narrow-cut-up (not different enough from naive-cut-up)
* naive-spoonerizer (not different enough from advanced-spoonerizer)

Anything in this repo not listed above is either a piece of lab equipment:

* fetch-chronam
* guten-gutter
* image-calipers

or a supply of lab materials:

* generic-corpora

[NaNoGenMo 2014]:         https://github.com/dariusk/NaNoGenMo-2014
[Cat's Eye Technologies]: http://catseye.tc/
[novel]:                  http://en.wikipedia.org/wiki/Novel
[decided]:                https://github.com/dariusk/NaNoGenMo-2014/issues/10#issuecomment-62053420
